/*******************************************
Keypad and LCD lock on Pic16f628A with 3*4 keypad
Project name: Combination Lock (Demonstration of the Keypad Library routines)
LCD Display in 4-bit mode on PORTA
Keypad on PORTB

Door1 = 05
Door2 = 28
Door1 & 2 = 33
Alarm off = 99

Three Attempts before Alarm

*****************************************/



char var1, var2, kp, attempts;
char state = 1;//start from state 1
int cnt=0;
char          text[] = "Combination Lock" ;//message text
void main(void) {

  CMCON = 0x07                     ;//PORTA to digital mode
  LCD_Config(&PORTA,7,6,5,3,2,1,0) ;//Pin assignment
                                   ;//RS,E,RW,D7,D6,D5,D4
  LCD_Cmd(LCD_CLEAR)               ;//Clear display
  LCD_Cmd(LCD_CURSOR_OFF)          ;//Turn cursor off
  LCD_Cmd(LCD_SECOND_ROW)          ;//Move to ROW2 for rest of program

  //Seup Keypad on PORTB
  Keypad_Init(&PORTB)              ;// Initialize Keypad on PORTB
   LCD_OUT(1,1,text)                ;//Print welcome message
  while(1) {   //while ever loop
               switch(state){ //check the current state
case 1:
               LCD_out(1,1,"Combination Lock");
               //LCD_Cmd(LCD_CLEAR)         ;
               while(!keypad_Read()){}   //wait for key1 press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
               var1=kp; //store var1 into kp
               state = 2;
               break;

case 2:
               if(kp==15) state=1; //go back state 1 when kp = # (enter key)
               else if(kp==13) state=1;//go back state 1 when kp = * (clear ke
               else
               state = 3;//go to state 3 get key2
               break;
case 3:
               while(!keypad_Read()){}   //wait for key2 press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
               var2=kp;//store var2 into kp
               state=4;
               break;
case 4:
               if(kp==15) state=1;//enter key goes back state 1
               else if(kp==13) state=1;//clear key goes back state 1
               else
               state = 5;//continue goes to state 4
               break;

 case 5:
               while(!keypad_Read()){}   //wait for enter key press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
               state = 6;
               break;
case 6:
               if(kp==13)
               state =1; //clear goes back to s1
               else if(kp==15)
               state = 7;//enter key goes to state 7
               else state = 5;
               break;
case 7:
               if (var1==14 && var2==6)//comparing for door1
                state = 12;  //goes state 11 open door1
               else state =8;
               break;
case 8:
               if (var1==2 && var2 == 10)//comparing for door2
               state = 13;//goes to state 9 for door 2
               else state=9;
               break;
case 9:
               if (var1==3 && var2 == 3)
               state = 14;//goes to state 13 for door1 & 2
               else
               state =10;
               break;
case 10:
               if(var1==11 && var2==11)
               state = 15;//goes to state 14 Alarm Off
               else
               state =11;
               break;
case 11:
               LCD_OUT(2,1,"Invalid CODE");
               while(!keypad_Read()){}   //wait for enter key press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
               if(kp==13)
               LCD_Cmd(LCD_CLEAR)         ;
               state =1        ;
               break;
case 12://open door1 for 5secs
              PORTA.F5=1;
              //Delay_ms(5000);
              state=1;
             Lcd_out(2,1,"Door1") ;
              while(!keypad_Read()){}   //wait for enter key press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
              if(kp==13)
              LCD_Cmd(LCD_CLEAR)         ;
              state=1;
              cnt=0;
              break;
case 13: //open door2 for 5secs
              LCD_OUT(2,1,"Door2");
              //PORTB.F4=1;
              //Delay_ms(5000);
              while(!keypad_Read()){}   //wait for enter key press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
              if(kp==13)
             LCD_Cmd(LCD_CLEAR)         ;
              state=1;
              cnt=0;
              break;
case 14: //open both doors
              LCD_OUT(2,1,"Door1&2");
              //PORTA.F5=1;
              //PORTB.F4=1;
              //Delay_ms(5000);
              while(!keypad_Read()){}   //wait for enter key press
               Delay_ms(10)             ;//debounce time
               kp = Keypad_Released()   ;//wait for release
              if(kp==13)
             LCD_Cmd(LCD_CLEAR)         ;
              state=1;
              cnt=0;
              break;
case 15:
              LCD_OUT(2,1,"*Alarm OFF*");
              Delay_ms(5000);
              LCD_Cmd(LCD_CLEAR)         ;
              state=1;
              cnt=0;
              break;
default:// must be a bad attempts
              attempts++;
              if(attempts ==3)
              LCD_OUT(2,1,"Alarm ON");
              state = 10;
              break;

                       }


                         }     }







              

/*
case 7:
                if (var1==3 && var2 == 3) //both doors open
               state = 13;
               else if (var1==11 && var2 == 11) // 99 turns alarm off
               state=1;
               else
               Lcd_out(2,1,"Bad Code");
               Delay_ms(2000);
               cnt++;
               state=1;
               break;   */
               

               

               
